/* 
 * File:   Interpolator_c.h
 * Author: mswindell
 *
 * Created on November 23, 2013, 11:11 PM
 */

#ifndef INTERPOLATOR_C_H
#define	INTERPOLATOR_C_H

#ifdef __cplusplus
#define _C_ "C"
#endif

#ifndef __cplusplus
#define _C_
#endif

extern _C_ int Interpolator_create();
extern _C_ int Interpolator_delete(int id);
extern _C_ int Interpolator_open(int id, const char * filename);
extern _C_ int Interpolator_load_variable(int id, const char * variable);
extern _C_ float Interpolator_interpolate(int id, const char * variable, float * c0,
		float * c1);
//extern _C_ void f_kameleon_unload_variable_(int *id, const char * variable);
extern _C_ void Interpolator_close(int id);
extern _C_ void Interpolator_create_c_string(const char * t_string, char * destbuffer);

#endif	/* INTERPOLATOR_C_H */

