#include "Interpolator_f.h"
#include "Interpolator_c.h"

#include <string>
#include <iostream>

void f_interpolator_create_(int * id){
    *id = Interpolator_create();
    int g = 2;
}

void f_interpolator_open_(int * id, const char * filename, int * status){

	std::string filename_str = filename;
	//get string length
	int length = filename_str.size();
	char filename_corrected[length+1];

	strcpy(filename_corrected, filename_str.c_str());
	//std::cout << "string length: " << length << std::endl;
	for (int i = 0; i< length; i++){
		if (filename_corrected[i] == ' '){
	//		std::cout << "add the character at index: " << i << std::endl;
			filename_corrected[i] = '\0';
			break;
		}

	}
//	std::cout << "filename: '" << filename_corrected << "'" << std::endl;
	*status = Interpolator_open(*id, filename_corrected);
}

void f_interpolator_load_variable_(int *id, const char * variable){
    
	std::string variable_str = variable;
	int length = variable_str.size();
	char variable_corrected[length+1];
	strcpy(variable_corrected, variable_str.c_str());
	for (int i = 0; i< length; i++)
	{
		if (variable_corrected[i] == ' ')
		{
			variable_corrected[i] = '\0';
			break;
		}
	}

//	std::cout << "variable_corrected: '" << variable_corrected << "'" << std::endl;
//	std::cout << "calling Kameleon_load_variable" << std::endl;
	Interpolator_load_variable(*id, variable_corrected);
//	std::cout << "finished calling Kameleon_load_variable" << std::endl;
}

void f_interpolator_interpolate_(int * id, const char * variable, float * lat,
		float * lon, float * returnValue){
    std::string variable_str = variable;
	//get string length
	int length = variable_str.size();
	char variable_corrected[length+1];
	strcpy(variable_corrected, variable_str.c_str());
	//std::cout << "string length: " << length << std::endl;
	for (int i = 0; i< length; i++)
	{
		if (variable_corrected[i] == ' ')
		{
	//		std::cout << "add the character at index: " << i << std::endl;
			variable_corrected[i] = '\0';
			break;
		}

	}
//	std::cout << "inside f_kameleon_interpolate. lat: " << *c1 << " mlt: " << *c2 << std::endl;
	*returnValue = Interpolator_interpolate(*id, variable_corrected, lat, lon);
	//std::cout << "Inside f_interpolator_interpolate: returnValue = " << *returnValue << std::endl;
	//*returnValue = Kameleon_interpolate(*id, variable_corrected, c0, c1, c2, dc0, dc1, dc2);
}

void f_interpolator_close_(int * id){
    Interpolator_close(*id);
    //std::cout<<"Returning from f_interpolator_close_"<<std::endl;
}

void f_interpolator_delete_(int * id, int * status){
    *status = Interpolator_delete(*id);
}
