/* 
 * File:   Interpolator_f.h
 * Author: mswindell
 *
 * Created on November 23, 2013, 10:47 PM
 */

#ifndef INTERPOLATOR_F_H
#define	INTERPOLATOR_F_H

#ifdef __cplusplus
#define _C_ "C"
#endif

#ifndef __cplusplus
#define _C_
#endif

extern _C_ void f_interpolator_create_(int * id);
extern _C_ void f_interpolator_delete_(int * id, int * status);
extern _C_ void f_interpolator_open_(int * id, const char * filename, int * status);
extern _C_ void f_interpolator_load_variable_(int *id, const char * variable);
extern _C_ void f_interpolator_interpolate_(int * id, const char * variable, float * c0,
		float * c1, float * returnValue);
//extern _C_ void f_kameleon_unload_variable_(int *id, const char * variable);
extern _C_ void f_interpolator_close_(int * id);
extern _C_ void f_timeinterp_timestrtoepoch_(const char * time_str, double * epoch);
extern _C_ void f_interpolator_create_c_string_(const char * t_string, char * destbuffer);

#endif	/* INTERPOLATOR_F_H */
